/*
Copyright Renaud GICQUEL 2008-2009  
renaud.gicquel@ensmp.fr

Ce logiciel est un programme informatique servant  modliser des systmes nergtiques.   

Ce logiciel est rgi par la licence CeCILL soumise au droit franais et respectant les principes de diffusion des logiciels libres. Vous pouvez utiliser, modifier et/ou redistribuer ce programme sous les conditions de la licence CeCILL telle que diffuse par le CEA, le CNRS et l'INRIA  sur le site "http://www.cecill.info".  

En contrepartie de l'accessibilit au code source et des droits de copie, de modification et de redistribution accords par cette licence, il n'est offert aux utilisateurs qu'une garantie limite.  Pour les mmes raisons, seule une responsabilit restreinte pse sur l'auteur du programme,  le titulaire des droits patrimoniaux et les concdants successifs.  

A cet gard  l'attention de l'utilisateur est attire sur les risques associs au chargement,   l'utilisation,   la modification et/ou au dveloppement et  la reproduction du logiciel par l'utilisateur tant  donn sa spcificit de logiciel libre, qui peut le rendre complexe   manipuler et qui le rserve donc  des dveloppeurs et des professionnels avertis possdant  des  connaissances  informatiques approfondies.  Les utilisateurs sont donc invits  charger  et  tester  l'adquation  du logiciel  leurs besoins dans des conditions permettant d'assurer la scurit de leurs systmes et ou de leurs donnes et, plus gnralement,   l'utiliser et l'exploiter dans les mmes conditions de scurit.   

Le fait que vous puissiez accder  cet en-tte signifie que vous avez  pris connaissance de la licence CeCILL, et que vous en avez accept les termes. 

This software is a computer program whose purpose is to model energy systems.  

This software is governed by the CeCILL  license under French law and abiding by the rules of distribution of free software.  You can  use,  modify and/ or redistribute the software under the terms of the CeCILL license as circulated by CEA, CNRS and INRIA at the following URL "http://www.cecill.info".   

As a counterpart to the access to the source code and  rights to copy, modify and redistribute granted by the license, users are provided only with a limited warranty  and the software's author,  the holder of the economic rights,  and the successive licensors  have only  limited liability.   

In this respect, the user's attention is drawn to the risks associated with loading,  using,  modifying and/or developing or reproducing the software by the user in light of its specific status of free software, that may mean  that it is complicated to manipulate,  and  that  also therefore means  that it is reserved for developers  and  experienced professionals having in-depth computer knowledge. Users are therefore encouraged to load and test the software's suitability as regards their requirements in conditions enabling the security of their systems and/or  data to be ensured and,  more generally, to use and operate it in the  same conditions as regards security.   

The fact that you are presently reading this means that you have had knowledge of the CeCILL license and that you accept its terms.  
*/

package extThopt;

import java.util.*; 
import javax.swing.*;
import rg.corps.*; 
/*
 * Modle d'une chambre flash pour solution aqueuse utilise pour le dessalement 
 * ou la concentration
 * Cette classe fait appel aux corps externes "EauSolute" ou "EauSalee" qui permettent 
 * de prendre en compte le retard  l'bullition
 */
public class FlashBrine extends ExtDivider implements Inversable
{
    protected static java.util.ResourceBundle resIntTh_fr = java.util.ResourceBundle.getBundle("IntTh",Locale.getDefault());  
    
	javax.swing.JLabel JLabel2 = new javax.swing.JLabel();
	javax.swing.JTextField Pflash_value = new javax.swing.JTextField();
	javax.swing.JLabel JLabel3 = new javax.swing.JLabel();
	javax.swing.JTextField loss_value = new javax.swing.JTextField();
	javax.swing.JLabel JLabel5 = new javax.swing.JLabel();
	javax.swing.JTextField Qgen_value = new javax.swing.JTextField();
	javax.swing.JLabel JLabel6 = new javax.swing.JLabel();
	javax.swing.JTextField Xpoor_value = new javax.swing.JTextField();
	javax.swing.JLabel JLabel7 = new javax.swing.JLabel();
	javax.swing.JTextField Xconc_value = new javax.swing.JTextField();
	javax.swing.JLabel JLabel8 = new javax.swing.JLabel();
	javax.swing.JTextField thermoCoupler1_value = new javax.swing.JTextField();
	javax.swing.JLabel JLabel10 = new javax.swing.JLabel();
	javax.swing.JTextField compRef = new javax.swing.JTextField();
	javax.swing.JRadioButton jcheckTsatEau = new javax.swing.JRadioButton();
	javax.swing.JRadioButton jcheckTsatEauSalee = new javax.swing.JRadioButton();
	javax.swing.JRadioButton bMode1 = new javax.swing.JRadioButton();
	final ButtonGroup groupCalcType=new ButtonGroup();
    
    double Tamont, Taval, Pamont, Paval,P,Pconc, Pflash, Tflash;
    double epsiSol,Qabs,Qgen,Tabs,Tgen,Xpoor,Xconc,mpoor,mconc,mbuees,Pbuees,Tbuees,Hbuees,Hconc,Hpoor,Tpoor,Ppoor;
    String poorSolutionProcess,bueesProcess,concSolutionProcess;
    String poorSolutionPoint,bueesPoint,concSolutionPoint;
    Vector[]vTransfo,vPoints;
    rg.corps.Corps produit;
    rg.corps.Corps eau;
	boolean isInitialized=false;
    
    public FlashBrine (){
        super();
		JPanel1.setLayout(null);
		JPanel1.setBounds(0,0,600,150);
		JLabel2.setText("flash pression (bar)");
		JPanel1.add(JLabel2);
		JLabel2.setBounds(0,22,164,20);
		JPanel1.add(Pflash_value);
		Pflash_value.setBounds(164,22,124,20);
		Pflash_value.setText("0.1");
//		Pflash_value.setEditable(false);
		JLabel8.setText("first thermocoupler load share");
//		JPanel1.add(JLabel8);
		JLabel8.setBounds(290,22,180,20);
//		JPanel1.add(thermoCoupler1_value);
		thermoCoupler1_value.setBounds(480,22,124,20);
		thermoCoupler1_value.setText("0.5");
		jcheckTsatEau.setText("Pure water saturation temperature");
		JPanel1.add(jcheckTsatEau);
		jcheckTsatEau.setBounds(0,85,250,20);
		jcheckTsatEauSalee.setText("Salted water saturation temperature");
		JPanel1.add(jcheckTsatEauSalee);
		jcheckTsatEauSalee.setBounds(0,105,250,20);
	    groupCalcType.add(jcheckTsatEau);
	    groupCalcType.add(jcheckTsatEauSalee);
		jcheckTsatEauSalee.setSelected(true);
//		JPanel1.add(loss_value);
		loss_value.setBounds(164,110,124,20);
		loss_value.setText("3");
		JLabel5.setText("thermal load");
//		JPanel1.add(JLabel5);
		JLabel5.setBounds(0,88,164,20);
//		JPanel1.add(Qgen_value);
		Qgen_value.setBounds(164,88,124,20);
		Qgen_value.setText("200");
		Qgen_value.setEditable(false);
		JLabel6.setText("Poor solution fraction");
		JPanel1.add(JLabel6);
		JLabel6.setBounds(0,44,164,20);
		JPanel1.add(Xpoor_value);
		Xpoor_value.setBounds(164,44,124,20);
		Xpoor_value.setText("0.6");
		Xpoor_value.setEditable(false);
		JLabel7.setText("Conc solution fraction");
		JPanel1.add(JLabel7);
		JLabel7.setBounds(0,66,164,20);
		JPanel1.add(Xconc_value);
		Xconc_value.setBounds(164,66,124,20);
		Xconc_value.setText("0.5");
		Xconc_value.setEditable(false);
		JLabel10.setText("reference");
		JPanel1.add(JLabel10);
		JLabel10.setBounds(0,186,108,20);
		JPanel1.add(compRef);
		compRef.setBounds(108,186,192,20);
		type=getType();
		thermoCouplerTypes=new String[0];
		compRef.setText("vapeur");
		
    }
    
    public String getType(){
        return "FlashBrine";
    }
    
	public String getClassDescription(){
	    return "FlashBrine class\n\no thermocoupler\n\nauthor : R. Gicquel   may 2009\n\nRef : ";
	}
    
    public void init(){
		isInitialized=true;
        Object obj=Corps.createSubstance(resIntTh_fr.getString("eau"));
        eau=(Corps)obj;
    }
    
	public void calculateProcess(){
	    if(!isInitialized)init();//la premire fois, on initialise, car il faut un constructeur sans argument
	
	    getDividerStructure();
        checkConsistency();
	    
	    if(isBuilt){
            Pflash=Util.lit_d(Pflash_value.getText());
            double Xmax=1.;
            Xconc=Util.dicho_T(this,0,1, "X_conc",Xpoor, Xmax,0.00001);//recherche de la concentration de sortie
	      
	        vTransfo= new Vector[nBranches+1];
	        vPoints= new Vector[nBranches+1];
            setupPoorSolution(mpoor,Tpoor,Ppoor,Xpoor);
            setupConcSolution(mconc,Tflash,Pflash,Xconc);
            setupBuees(mbuees,Tbuees,Pflash,1);
            updateDivider(vTransfo,vPoints,Tpoor,Hpoor);

	        Xpoor_value.setText(Util.aff_d(Xpoor,5));
	        Xconc_value.setText(Util.aff_d(Xconc,5));
        }

	}
	
    
    double getOutletConcentration(double T, double X){
            
        if(jcheckTsatEauSalee.isSelected())Tflash=produit.getSatTemperature(Pflash,X);
        else Tflash=eau.getSatTemperature(Pflash,X);
        
	    Tbuees=Tflash;
	    eau.CalcPropCorps(Tbuees,Pflash,1);
	    Hbuees=eau.getState()[5];

        mconc=mpoor*Xpoor/X;//concentration en sortie
        mbuees=mpoor-mconc;//dbit de vapeur
                        
        produit.CalcPropCorps(Tflash,Pflash,X) ;
        getSubstProperties(nomCorps);
        Hconc=Hsubst;

        double z=mconc*Hconc+mbuees*Hbuees-mpoor*Hpoor;
        return z;
    }
	
    private void setupPoorSolution(double m, double T, double P, double X){
        vTransfo[0]=new Vector();
        vPoints[0]=new Vector();
        vTransfo[0].addElement(poorSolutionProcess);
        vTransfo[0].addElement(new Double(m));
 
        vPoints[0].addElement(poorSolutionPoint);
        vPoints[0].addElement(new Double(T));
        vPoints[0].addElement(new Double(P));
        vPoints[0].addElement(new Double(X));
    }
    private void setupConcSolution(double m, double T, double P, double X){
        vTransfo[1]=new Vector();
        vPoints[1]=new Vector();
        vTransfo[1].addElement(concSolutionProcess);
        vTransfo[1].addElement(new Double(m));
 
        vPoints[1].addElement(concSolutionPoint);
        vPoints[1].addElement(new Double(T));
        vPoints[1].addElement(new Double(P));
        vPoints[1].addElement(new Double(X));
    }
    private void setupBuees(double m, double T, double P, double X){
        vTransfo[2]=new Vector();
        vPoints[2]=new Vector();
        vTransfo[2].addElement(bueesProcess);
        vTransfo[2].addElement(new Double(m));
 
        vPoints[2].addElement(bueesPoint);
        vPoints[2].addElement(new Double(T));
        vPoints[2].addElement(new Double(P));
        vPoints[2].addElement(new Double(X));
    }
  
    private void checkConsistency(){
	    String[] args=new String[2];
	    Vector[] vBranch=new Vector[2];
        isBuilt=true;
        concSolutionProcess="";
        bueesProcess="";
     if(nBranches!=2){
	        String msg = "Error on the number of branches which is "+nBranches+" instead of 2";
	        JOptionPane.showMessageDialog(de, msg);  
	        isBuilt=false;
        }
        else{
            for(int j=0;j<nBranches;j++){
	            args[0]="process";//type of the element (see method getProperties(String[] args))
	            args[1]=nomBranche[j];//name of the process (see method getProperties(String[] args))
                vBranch[j]=proj.getProperties(args);
	            String amont=(String)vBranch[j].elementAt(1);//gets the upstream point name
	            getPointProperties(amont);//direct parsing of point property vector
                String nom=nomCorps;
                //Check the substance at inlet
                System.out.println(" ligne "+j+" nomCorps "+nomCorps);
	            if(!nom.equals(resIntTh_fr.getString("eau"))){
	                concSolutionProcess=nomBranche[j];
	                concSolutionPoint=amont;
	                Pconc=Ppoint;
	                Xconc=Xpoint;
	            }
	            if(nom.equals(resIntTh_fr.getString("eau"))){
	                bueesProcess=nomBranche[j];
	                bueesPoint=amont;
	                Pbuees=Ppoint;
	                Hbuees=Hpoint;
	                Tbuees=Tpoint;
	            }
	        }
	        if((bueesProcess.equals(""))||(concSolutionProcess.equals(""))){
	            String msg = "Error on at least one of the branch substances";
	            JOptionPane.showMessageDialog(de, msg);  
	            isBuilt=false;
	        }
        }
        poorSolutionProcess=mainProcess;
	    args[0]="process";//type of the element (see method getProperties(String[] args))
	    args[1]=poorSolutionProcess;//name of the process (see method getProperties(String[] args))
	    Vector vPropMain=proj.getProperties(args);
	    Double f=(Double)vPropMain.elementAt(3);
	    mpoor=f.doubleValue();
	    String aval=(String)vPropMain.elementAt(2);//gets the downstream point name
	    getPointProperties(aval);//direct parsing of point property vector
	    poorSolutionPoint=aval;
	    Tpoor=Tpoint;
	    Ppoor=Ppoint;
	    Hpoor=Hpoint;
	    Xpoor=Xpoint;
        String nom=nomCorps;
        args[0]="point";
        args[1]=aval;
	    vPropMain=proj.getProperties(args);
	    produit=(rg.corps.Corps)vPropMain.elementAt(0);
	    
        
        
        //Check the substance at inlet
/*	    if(!(nom.equals("eau sale"))){
	        String msg = "Error on main process substance,which is "+nomCorps+" instead of LiBr-H2O mixture";
	        JOptionPane.showMessageDialog(de, msg);  
	        isBuilt=false;
	    }*/
        
    }
  
	public void readCompParameters(String ligne_data){
		Tgen=Util.lit_d(Util.extr_value(ligne_data, "Pflash_value"));
	    Pflash_value.setText(Util.aff_d(Tgen,3));
		Qgen=Util.lit_d(Util.extr_value(ligne_data, "Qgen_value"));
	    Qgen_value.setText(Util.aff_d(Qgen,3));
		Xpoor=Util.lit_d(Util.extr_value(ligne_data, "Xpoor_value"));
	    Xpoor_value.setText(Util.aff_d(Xpoor,3));
		Xconc=Util.lit_d(Util.extr_value(ligne_data, "Xconc_value"));
	    Xconc_value.setText(Util.aff_d(Xconc,3));
        String valeur=Util.extr_value(ligne_data, "compRef");
        if(valeur!=null)compRef.setText(valeur);
        valeur=Util.extr_value(ligne_data, "loss_value");
        if(valeur!=null)loss_value.setText(valeur);
        valeur=Util.extr_value(ligne_data, "thermoCoupler1_value");
        if(valeur!=null)thermoCoupler1_value.setText(valeur);
        valeur=Util.extr_value(ligne_data, "calcTsatEau");
        if(valeur!=null)jcheckTsatEau.setSelected(Util.lit_b(valeur));
	}
	
    public String saveCompParameters(){
	    String h="Pflash_value="+Pflash_value.getText()+tab
	    +"Qgen_value="+Qgen_value.getText()+tab
	    +"Xpoor_value="+Xpoor_value.getText()+tab
	    +"Xconc_value="+Xconc_value.getText()+tab
	    +"loss_value="+loss_value.getText()+tab
	    +"calcTsatEau="+Util.aff_b(jcheckTsatEau.isSelected())+tab
	    +"thermoCoupler1_value="+thermoCoupler1_value.getText()+tab
	    +"compRef="+compRef.getText()+tab
	    ;
        return h;
    }
    public double f_dicho(double X, double T,String fonc){
        
        if (fonc.equals("X_conc"))return getOutletConcentration(T,X);
            
        
        return 0;
        
    }
 


}